CREATE DATABASE WMS
GO

CREATE TABLE Clients(
	ClientId INT PRIMARY KEY IDENTITY
	, FirstName NVARCHAR(50)
	, LastName NVARCHAR(50)
	, Phone CHAR(12)
	)

CREATE TABLE Mechanics (
	MechanicId INT PRIMARY KEY IDENTITY
	, FirstName NVARCHAR(50)
	, LastName NVARCHAR(50)
	, Address NVARCHAR(50)
	)

CREATE TABLE Jobs (
	JobId INT PRIMARY KEY IDENTITY
	, ModelId INT 
	, Status NVARCHAR(11) CHECK (Status IN ('Pending', 'In Progress', 'Finished')) DEFAULT 'Pending'
	, ClientId INT FOREIGN KEY REFERENCES Clients(ClientId)
	, MechanicId INT FOREIGN KEY REFERENCES Mechanics(MechanicId) NULL
	, IssueDate DATE
	, FinishDate DATE NULL
	)


CREATE TABLE Models (
	ModelId INT PRIMARY KEY IDENTITY
	, Name NVARCHAR(50) UNIQUE
	)

CREATE TABLE Orders (
	OrderId INT PRIMARY KEY IDENTITY
	, JobId INT FOREIGN KEY REFERENCES Jobs(JobId)
	, IssueDate DATE NULL
	, Delivered VARCHAR(6) DEFAULT 'False' CHECK(Delivered IN ('FALSE', 'TRUE'))
	)

CREATE TABLE Parts (
	PartId INT PRIMARY KEY IDENTITY
	, SerialNumber NVARCHAR(50) UNIQUE
	, Description NVARCHAR (255) NULL
	, Price DECIMAL(7,2) NULL
	, VendorId INT 
	, StockQty INT CHECK (StockQty >= 0) DEFAULT 0
	)

CREATE TABLE OrderParts (
	OrderId INT FOREIGN KEY REFERENCES Orders(OrderId) IDENTITY
	, PartId INT FOREIGN KEY REFERENCES Parts(PartId)
	, Quantity INT CHECK (Quantity > 0) DEFAULT 1
	, PRIMARY KEY (OrderId,PartId)
	)

CREATE TABLE PartsNeeded (
	JobId INT FOREIGN KEY REFERENCES Jobs(JobId) IDENTITY
	, PartId INT FOREIGN KEY REFERENCES Parts(PartId)
	, Quantity INT CHECK (Quantity > 0) DEFAULT 1
	, PRIMARY KEY (JobId ,PartId )  
	)

CREATE TABLE Vendors (
	VendorId INT PRIMARY KEY IDENTITY
	, Name NVARCHAR(50) UNIQUE
	)

ALTER TABLE Jobs
ADD FOREIGN KEY (ModelId)
REFERENCES Models(ModelId)


ALTER TABLE Parts
ADD FOREIGN KEY (VendorId)
REFERENCES Vendors(VendorId)


